SET i asset /i1*i5/;
SET s scenarios /s1*s100/;

SCALARS
Scen number of scenarios /100/
alpha level alpha /0.05/
w_0 initial wealth /100/
w_tilde expected wealth /114/;

TABLE rho(s,i)  returns
$INCLUDE "rho.txt";

Positive variables z(s), x(i);
Variables a, obj, w(s);

EQUATIONS        CVaRobj,
                 adjusted_loss(s)
                 expReturn
                 wealth_def(s)
                 budget;

CVaRobj..             obj =e= - a + 1/alpha * sum(s, z(s)*1/Scen);
adjusted_loss(s)..    - a + w(s) +z(s) =g= 0;
expReturn..           1/Scen * sum(s, w(s)) =g= w_tilde;
wealth_def(s)..       w(s) - w_0*sum(i,x(i)*rho(s,i)) =e= 0;
budget..              sum(i,x(i)) =e= 1;

*------------------------------------------------------------------------------
* Model declaration

MODEL CVaRmin /all/ ;


SOLVE  CVaRmin minimizing obj using LP;

